﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2019 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using HEAL.Attic;
using HeuristicLab.Common;
using HeuristicLab.Core;
using HeuristicLab.Encodings.SymbolicExpressionTreeEncoding;
using System.Collections.Generic;

namespace HeuristicLab.Algorithms.EvolvmentModelsOfModels {
  [Item("ZeroMap", "A map of models of models of models")]
  [StorableType("FF199AE7-DF0A-4E2A-99BC-BECD647E18F0")]
  public class EMMZeroMap : EMMMapBase<ISymbolicExpressionTree> {
    #region conctructors
    [StorableConstructor]
    protected EMMZeroMap(StorableConstructorFlag _) : base(_) { }
    public EMMZeroMap() {
      ModelSet = new List<ISymbolicExpressionTree>();
    }
    public override IDeepCloneable Clone(Cloner cloner) {
      return new EMMZeroMap(this, cloner);
    }
    public EMMZeroMap(EMMZeroMap original, Cloner cloner) : base(original, cloner) { }
    #endregion
    #region MapApplayFunctions
    override public void CreateMap(IRandom random, int k) { }
    override public ISymbolicExpressionTree NewModelForInizializtionNotTree(IRandom random, out int treeNumber) {
      return NewModelForInizializtion(random, out treeNumber);
    }
    public override ISymbolicExpressionTree NewModelForMutation(IRandom random, out int treeNumber, int parentTreeNumber) {
      treeNumber = random.Next(ModelSet.Count);
      return (ISymbolicExpressionTree)ModelSet[treeNumber].Clone();
    }
    #endregion

  }
}
